/* CHK=0x8848 */
char *rev = "3.30";

/* #define FORCE_DASH_G */

#if defined(WHT) && !defined(FORCE_DASH_G)
#define FORCE_DASH_G
#endif

/*+-------------------------------------------------------------------------
	config.c - Makefile configuration program for ECU
	wht@n4hgf.atl.ga.us

  This must be compiled with the *NATIVE* cc or else you must
  fake all of the predefines the native compiler supplies.  The
  Configure script can pass stuff in CFLAGS to tickle config a
  bit.

  There are a few tricks in here for SCO multi-target development
  system.  If you compile this on a UNIX system, but specify the
  target for a XENIX system, you get the cc -xenix switch.  You
  also get -Dconst= to avoid banging into some problems with the
  XENIX stuff in the header files.

  'I love it.  God help me, I love it so.  I love it more than my
  life.' -- George C.  Scott as Patton in _Patton_

  Defined functions:
	gen_cc_cflags()
	gen_gcc_cflags()
	gen_isc_ldflags()
	gen_sco_ldflags()
	gen_sun_ldflags()
	gen_solaris2_ldflags()
	gen_svr4_ldflags()
	gen_bsd_ldflags()
	generate_config(mdir)
	goodbye(sig)
	main(argc,argv)
	tgetc()
	tgetopt(prompt,choices,deflt)
	tgets(buf)
	tputstrs(strs)
	tputstrsfp(strs)

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-04-1994-04:38-wht@n4hgf-ECU release 3.30 */
/*:05-02-1994-03:10-wht@fep-cannot fix for all: warn of gcc overflow warnings */
/*:04-05-1994-17:11-wht@n4hgf-correct my first ever = for == substitution */
/*:03-13-1994-16:28-wht@fep-add Motorola SVR4 */
/*:01-25-1994-17:36-wht@n4hgf-USE_DECIMAL_PIDS->CFG_BinaryUucpPids */
/*:01-04-1994-07:23-wht@fep-implement intdial_to and INTDIAL_TO */
/*:12-12-1993-13:44-wht@fep-use enum to catch missing cases */
/*:12-12-1993-13:36-wht@fep-remove obsolete -DISC22 */
/*:12-12-1993-13:31-wht@fep-MOTSVR3 == Motorola Delta SVR3 for 88k */
/*:12-10-1993-22:09-wht@n4vu-more Linux fixes + add sun -DCFG_TermiosLineio */
/*:12-02-1993-15:44-wht@n4hgf-some Linux includes may be root-readable only */
/*:11-14-1993-12:33-wht@n4hgf-HP-UX port by Carl Wuebker at HP */
/*:11-12-1993-11:00-wht@n4hgf-Linux changes by bob@vancouver.zadall.com */
/*:10-04-1993-04:07-wht@n4hgf-simplify SCO optimization choice */
/*:08-30-1993-11:44-wht@n4hgf-remove obsolete i86-specific gcc opts */
/*:08-17-1993-04:14-wht@n4hgf-Wuninitialized always on */
/*:08-17-1993-04:14-wht@n4hgf-remove -fforce-mem/-fforce-addr from gcc flags */
/*:03-17-1993-14:55-wht@n4hgf-remove soon to be obsolete LNG353 warnings */
/*:02-16-1993-13:18-wht@n4hgf-remove -Mlt128 from 286 per vancleef@netcom.com */
/*:01-30-1993-13:20-wht@n4hgf-add -Wuninitialized */
/*:01-30-1993-12:06-wht@n4hgf-gcc 2.3.3 gets -O6 */
/*:01-21-1993-00:07-wht@n4hgf-32v4 now the SCO UNIX default */
/*:01-21-1993-00:06-wht@n4hgf-augment gcc switches */
/*:12-12-1992-12:22-wht@n4hgf-no built in functions when using gcc */
/*:09-10-1992-13:58-wht@n4hgf-ECU release 3.20 */
/*:09-10-1992-04:39-wht@n4hgf-admonition about SunOS IPC config */
/*:08-22-1992-15:38-wht@n4hgf-ECU release 3.20 BETA */
/*:08-21-1992-13:46-wht@n4hgf-don't configure ecuungetty if not used on a sys */
/*:08-11-1992-06:04-wht@n4hgf-FORCE_DASH_G and 3.2v4 LNG353 warnings */
/*:07-12-1992-07:17-wht@n4hgf-3.2v4 has a fully functional nap and select */
/*:07-02-1992-20:41-wht@n4hgf-rework for more options + 3.2v4 PID_T */
/*:06-18-1992-11:19-root@n4hgf-SCO 3.2v4 gcc CFLAG additions */
/*:04-23-1992-14:04-wht@n4hgf-had XENIX curses lib paths wrong */
/*:04-19-1992-21:55-wht@n4hgf-pressing return or enter gets tgeopt default */
/*:04-19-1992-21:43-wht@n4hgf-add default for tgetopt */
/*:04-19-1992-02:55-wht@n4hgf-add ESIX SVR4 config */
/*:04-17-1992-20:08-wht@n4hgf-add tty, baud and parity questions */
/*:03-20-1992-03:08-wht@n4hgf-correct XENIX tcap/tlib test thanks to tbetz */
/*:03-01-1992-13:36-wht@n4hgf-add -Wswitch to gcc compiles */
/*:02-06-1992-15:23-wht@n4hgf-depressing ... SCO keeps chging their minds */
/*:10-17-1991-14:51-wht@n4hgf-add can_pipe code */
/*:09-03-1991-12:53-wht@n4hgf2-iron out sun gcc options */
/*:09-01-1991-16:32-wht@n4hgf2-show package and config versions */
/*:09-01-1991-15:59-wht@n4hgf2-generalize HDB Devices, etc. files location */
/*:08-28-1991-14:07-wht@n4hgf2-SVR4 cleanup by aega84!lh */
/*:08-25-1991-14:39-wht@n4hgf-SVR4 port thanks to aega84!lh */
/*:08-23-1991-01:37-wht@n4hgf-sun port */
/*:07-25-1991-12:55-wht@n4hgf-ECU release 3.10 */
/*:07-12-1991-14:02-wht@n4hgf-GCC140 update */
/*:05-02-1991-02:46-wht@n4hgf-take out M_TERMCAP in favor of ecucurses.h */
/*:04-28-1991-03:44-wht@n4hgf-add -Dconst= for X286 under UNIX */
/*:04-20-1991-17:26-wht@n4hgf-creation */

#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>

#include "ecu_config.h"
#include "ecu_types.h"
#include "ecu_stat.h"
#include "patchlevel.h"

#if defined(CFG_TermiosLineio)
#include <termios.h>
#define	termio	termios
#define	setty(arg) tcsetattr(0,TCSADRAIN,(arg) ? &tty1 : &tty0)
#else
#include <termio.h>
#define setty(arg) ioctl(0,TCSETAW,(arg) ? (char *)&tty1 : (char *)&tty0)
#endif

struct termio tty0;
struct termio tty1;

#define	CBUFSIZE	128

enum sys_type
{
	S_SCO,
	S_ISC,
	S_SUN,
	S_ISCSVR4,
	S_ESIXSVR4,
	S_LINUX,
	S_HPUX,
	S_MOTSVR3,
	S_MOTSVR4,
	S_BSD,
	S_SOLARIS2,
};

enum sco_type
{
	X_X286,
	X_X386,
	X_UNIX,
	X_32v4,
};

enum cc_type
{
	C_CC,
	C_GCC,
};

char *makedirs[] =
{
	".",
	"./bperr",
	"./ecufriend",
	"./ecuungetty",
	"./gendial",
	"./help",
	"./sea",
	"./z",
	(char *)0
};

char *strs_intro1[] =
{
	"\n",
	".-------------------.\n",
	"| ECU configuration |\n",
	"`-------------------'\n",
	(char *)0
};
char *strs_intro2[] =
{
#ifdef WHT
	"WHT features enabled.  ",
#endif
#if defined(FORCE_DASH_G)
	"-g compilation will be forced.",
#endif
	"\n",
	"\n",
	"Please answer these questions so that I can configure ECU.\n",
	"There are two types of answers, single character and string.\n",
	"Single character questions have the choices in () followed by a ?\n",
	"String questions are followed by a :\n",
	"Default answers appearing in [] are guesses.  If you wish to use\n",
	"the default answer for a question, just press CR\n",
	"\n",
	"Abort (DEL, ^C, etc.) now if you do not wish to continue\n",
	(char *)0
};

char *strs_no_timeval[] =
{
	"\n",
	"I am supposed to use select() for a nap() replacement, but I can't find\n",
	"a definition for `struct timeval' in sys/time.h nor sys/select.h\n",
	"By all means try a compile, but expect `unknown size', 'undefined' and\n",
	"other type error messages associated with missing struct definitions.\n",
	"Communicate your particulars to wht@n4hgf.atl.ga.us, PLEASE!\n",
	(char *)0
};

char *strs_mkdep[] =
{
	"\n",
	"You are ready to make the program. It make take a while (now is a good\n",
	"time to Read The Fine Manual).\n",
	"\n",
	"You MAY wish to make depend first.  It is not necessary to do this\n",
	"until you make source modifications or apply patches.\n",
	(char *)0
};

char *sco_cc_opts[] =
{
	"\t-M2e -LARGE -i -O\\\n",	/* XENIX/286 */
	"\t-M3e -O \\\n",		 /* XENIX/386 */
	"\t-M3e -O \\\n",		 /* UNIX/386 3.2.0-3.2v2 */
	"\t-M3e -O \\\n"		 /* UNIX/386 3.2v4 */
};

char *sco_sigtype[] =
{
	"int",					 /* XENIX/286 */
	"void",					 /* XENIX/386 */
	"void",					 /* UNIX/386 3.2.0-3.2v2 */
	"void"					 /* UNIX/386 32v4 */
};

char *pid_type = "\t-DPID_T=int \\\n";

/*
 * GCC CFLAGS
 */
char *gcc_opts[] =
{
#ifdef PEDANTIC
	"\t-pedantic -ansi -O -fno-builtin\\\n",	/* UH OH: see ecu README */
#else
	"\t-traditional -O -fno-builtin\\\n",
#endif
#if defined(FORCE_DASH_G)
	"\t-g \\\n",
#endif
	"\t-fpcc-struct-return -fwritable-strings -finline-functions\\\n",
	"\t-W -Wuninitialized -Wunused -Wshadow -Wcomment -Wswitch\\\n",
	"\t-Dconst=\\\n",
	(char *)0
};

char *sco_gcc_opts[] =
{

 /*
  * XENIX/286
  */
	"\t........what-goes-here?......... \\\n",

 /*
  * XENIX/386
  */
	"\t-DM_XENIX -DM_SYSV -DM_SYS5 -DM_I386 \\\n\
\t-DM_BITFIELDS -DM_COFF -DM_I386 -DM_I86 -DM_I86SM \\\n\
\t-DM_INTERNAT -DM_SDATA -DM_STEXT -DM_SYS3 \\\n\
\t-DM_SYSIII -DM_WORDSWAP -Di386\\\n",

 /*
  * UNIX/386 3.2.0..3.2v2
  */
	"\t-DM_BITFIELDS -DM_COFF -DM_I386 -DM_I86 -DM_I86SM \\\n\
\t-DM_INTERNAT -DM_SDATA -DM_STEXT -DM_SYS3 -DM_SYS5 \\\n\
\t-DM_SYSIII -DM_SYSV -DM_UNIX -DM_WORDSWAP -DM_XENIX -Dunix -Di386\\\n",

 /*
  * UNIX/386 3.2v4
  */
	"\t-D_NO_PROTOTYPE -D_SVID -D_KR -D__STDC__=0 \\\n\
\t-DM_BITFIELDS -DM_COFF -DM_I386 -DM_I86 -DM_I86SM \\\n\
\t-DM_INTERNAT -DM_SDATA -DM_STEXT -DM_SYS3 -DM_SYS5 \\\n\
\t-DM_SYSIII -DM_SYSV -DM_UNIX -DM_WORDSWAP -DM_XENIX -Dunix -Di386\\\n",
};

char *motsvr3_cc_opts = "\t-O -DMOTSVR3 \\\n";
char *motsvr3_gcc_opts = "\t-DMOTSVR3 \\\n";
char *motsvr3_sigtype = "void";

char *isc_cc_opts = "\t-O -DISC \\\n";
char *isc_gcc_opts = "\t-DISC -Di386\\\n";
char *isc_sigtype = "void";

char *sun_cc_opts = "\t-O \\\n";
char *sun_gcc_opts = "\t-Dsun=1 \\\n";	/* ansi gets __sun__ only */
char *sun_sigtype = "void";

char *solaris2_cc_opts = "\t-Dsun=1 -DSVR4 -DCFG_GettodFtime \\\n";
char *solaris2_gcc_opts = "\t-Dsun=1 -DSVR4 -DCFG_GettodFtime \\\n";

char *hpux_cc_opts = "\t-O -Dhpux=1\\\n";
char *hpux_gcc_opts = "\t-Dhpux=1 \\\n";
char *hpux_sigtype = "void";

char *svr4_cc_opts = "\t-O -DSVR4 \\\n";
char *svr4_gcc_opts = "\t-DSVR4 \\\n";
char *svr4_sigtype = "void";

char *linux_gcc_opts = "\t-DLINUX -Di386 \\\n";
char *linux_sigtype = "void";

char *bsd_gcc_opts = "\t-DBSD";
char *bsd_sigtype = "void";

/*
 * LIBS
 */
char *_sco_libs[] =
{
	"-ltcap -ltermlib -lx",
	"-ltcap -ltermlib -lx",
	"-ltcap -ltermlib -lmalloc -lc_s -lc -lx",
	"-ltcap -ltermlib -lmalloc -lc_s -lc -lx"
};
char *_sco2_libs[] =
{
	"-ltcap -ltermcap -lx",
	"-ltcap -ltermcap -lx",
	"-ltcap -ltermcap -lmalloc -lc_s -lc -lx",
	"-ltcap -ltermcap -lmalloc -lc_s -lc -lx"
};
char **sco_libs = _sco_libs;

char *isc_libs = "-lcurses -linet -lmalloc -lc_s -lc -lx";

char *motsvr3_libs = "-lcurses -ltermcap";

char *sun_libs = "-lcurses -ltermcap";

char *solaris2_libs = "-lcurses -ltermcap -lmalloc";

char *svr4_libs = "-lcurses -lx -lmalloc";

char *linux_libs = "-lncurses";

char *hpux_libs = "-lcurses -ltermcap";

char *bsd_libs = "-lcurses -ltermcap";

char *sco_system[] =
{
	"XENIX/286",
	"XENIX/386",
	"UNIX/386",
	"UNIX/386 3.2v4"
};

int intdial_to = 60;

char *malloc_3x = "\t-DMALLOC_3X \\\n";

char *tty = "tty1a";
char *baud = "9600";
int parity = 0;
char *bindir = "/usr/local/bin";
char *libdir = "/usr/local/lib/ecu";
char *symbolic = "";
char *use_ecuungetty = "no";

int sys = -1;
int compiler = -1;
int sco_type = -1;
int debug = 0;
int can_pipe = 0;
int has_fd_set = 0;
int has_timeval = 0;
int need_timeval = 0;
int need_select_h = 0;

FILE *fpmake;

void
goodbye(sig)
int sig;
{
	setty(0);
	printf("\n");
	exit(sig);
}

void
tputstrs(strs)
char **strs;
{
	while (*strs)
		fputs(*strs++, stdout);
}

void
tputstrsfp(strs)
char **strs;
{
	while (*strs)
		fputs(*strs++, fpmake);
}

char
tgetc()
{
	char rtn;

	setty(1);
	read(0, &rtn, 1);
	rtn &= 0x7F;
	setty(0);
	if (rtn != 0x0A)
		printf("\n", rtn);
	return (rtn);
}

void
tgets(buf)
char *buf;
{
	char *tmp;

	if (!(fgets(buf, CBUFSIZE, stdin)))
		goodbye(1);

	if ((tmp = strchr(buf, '\n')))
		*tmp = '\0';
}

char
tgetopt(prompt, choices, deflt)
char *prompt;
char *choices;
char deflt;
{
	char rtn = 0;
	char response;
	char *cptr;

	printf("\n%s (", prompt);
	while (!rtn)
	{
		cptr = choices;
		while (*cptr)
		{
			if (cptr - choices)
				putchar(',');
			if (*cptr == deflt)
				putchar('[');
			putchar(*cptr);
			if (*cptr == deflt)
				putchar(']');
			cptr++;
		}
		printf(")? ");
		response = tgetc();
		if (strchr(choices, response))
			rtn = response;
		else if ((response == 0x0D) || (response == 0x0A))
			rtn = deflt;
		else
			printf("Please answer with one of (");
	}
	return (rtn);
}

void
gen_cc_cflags()
{

	fputs("CFLAGS = \\\n", fpmake);
	switch (sys)
	{
		case S_SCO:
#ifdef M_UNIX
			fputs("\t-nointl \\\n", fpmake);
			if ((sco_type != X_UNIX) && (sco_type != X_32v4))
				fputs("\t-xenix -Dconst= \\\n", fpmake);
#endif
			fputs(sco_cc_opts[sco_type], fpmake);
			if ((sco_type == X_UNIX) || (sco_type == X_32v4))
				fputs(malloc_3x, fpmake);
			if (sco_type == X_32v4)
			{
				fputs("\t-DSCO32v4 \\\n", fpmake);
				fputs("\t-DCFG_SelectNap \\\n", fpmake);
				need_timeval = 1;
			}
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/uucp\"' \\\n", fpmake);
			break;
		case S_ISC:
			fputs(isc_cc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/locks\"' \\\n", fpmake);
			break;
		case S_MOTSVR3:
			fputs(motsvr3_cc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_GettodFtime -DCFG_FionrdRdchk \\\n",
				fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/locks\"' \\\n", fpmake);
			break;
		case S_SUN:
			fputs(sun_cc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_TermiosLineio \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_FionrdRdchk \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_SOLARIS2:
			fputs(solaris2_cc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_TermiosLineio \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_FionrdRdchk \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_HPUX:
			fputs(hpux_cc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_FionrdRdchk\\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_BinaryUucpPids\\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/uucp\"' \\\n", fpmake);
			break;
		case S_ISCSVR4:
			fputs(svr4_cc_opts, fpmake);
			fputs("\t-DISCSVR4 \\\n", fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_ESIXSVR4:
			fputs(svr4_cc_opts, fpmake);
			fputs("\t-DESIXSVR4 \\\n", fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_MOTSVR4:
			fputs(svr4_cc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_TermiosLineio \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
	}

}

void
gen_gcc_cflags()
{
	char **strs;

	fputs("CFLAGS = \\\n", fpmake);
	strs = gcc_opts;
	while (*strs)
		fputs(*strs++, fpmake);
	if (can_pipe)
		fputs("\t-pipe \\\n", fpmake);
	switch (sys)
	{
		case S_SCO:
			fputs(sco_gcc_opts[sco_type], fpmake);
			if ((sco_type == X_UNIX) || (sco_type == X_32v4))
				fputs(malloc_3x, fpmake);
			if (sco_type == X_32v4)
			{
				fputs("\t-DCFG_SelectNap -DSCO32v4 \\\n", fpmake);
				need_timeval = 1;
			}
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/uucp\"' \\\n", fpmake);
			break;
		case S_ISC:
			fputs(isc_gcc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/locks\"' \\\n", fpmake);
			break;
		case S_MOTSVR3:
			fputs(motsvr3_gcc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_GettodFtime \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_FionrdRdchk \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/locks\"' \\\n", fpmake);
			break;
		case S_SUN:
			fputs(sun_gcc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_TermiosLineio \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_FionrdRdchk \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_SOLARIS2:
			fputs(solaris2_gcc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_TermiosLineio \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_FionrdRdchk \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_ISCSVR4:
			fputs(svr4_gcc_opts, fpmake);
			fputs("\t-DISCSVR4 \\\n", fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_ESIXSVR4:
			fputs(svr4_gcc_opts, fpmake);
			fputs("\t-DESIXSVR4 \\\n", fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_MOTSVR4:
			fputs(svr4_gcc_opts, fpmake);
			fputs(malloc_3x, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_TermiosLineio \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/locks\"' \\\n", fpmake);
			break;
		case S_LINUX:
			fputs(linux_gcc_opts, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_FionrdRdchk \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_TermiosLineio \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/uucp\"' \\\n", fpmake);
			break;
		case S_HPUX:
			fputs(hpux_gcc_opts, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_FionrdRdchk \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_BinaryUucpPids\\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/usr/spool/uucp\"' \\\n", fpmake);
			break;
		case S_BSD:
			fputs(bsd_gcc_opts, fpmake);
			fputs("\t-DCFG_SelectNap -DCFG_FionrdRdchk \\\n", fpmake);
			need_timeval = 1;
			fputs("\t-DCFG_TermiosLineio \\\n", fpmake);
			fputs("\t-DCFG_MmapSHM -DCFG_GettodFtime \\\n", fpmake);
			fputs("\t-DNO_ANSI_EMULATION \\\n", fpmake);
			fputs("\t-DLOCK_DIR_NAME='\"/var/spool/lock\"' \\\n", fpmake);
			break;
	}
}

void
gen_common_cflags()
{
	fputs("\t-DSIGTYPE=$(SIGTYPE) \\\n", fpmake);
	if (has_fd_set || need_select_h)
	{
		fprintf(fpmake, "\t%s%s\\\n",
			(has_fd_set) ? "-DCFG_HasFdSet " : "",
			(need_select_h) ? "-DCFG_IncSelectH " : "");
	}
	if (*use_ecuungetty == 'y')
		fputs("\t-DCFG_UseUngetty -DCFG_UngettyChown \\\n", fpmake);
	fprintf(fpmake, "\t-DDEFAULT_TTY='\"/dev/%s\"' \\\n", tty);
	fprintf(fpmake, "\t-DDEFAULT_BAUD_RATE=%s \\\n", baud);
	fprintf(fpmake, "\t-DDEFAULT_PARITY=\"'%c'\" \\\n", parity);
	fprintf(fpmake, "\t-DINTDIAL_TO=%d \\\n", intdial_to);
	fputs("\t-DHDBLIBDIR='\"$(HDBLIBDIR)\"' \\\n", fpmake);
	fputs("\t-DECULIBDIR='\"$(ECULIBDIR)\"' \\\n", fpmake);
	fputs(pid_type, fpmake);
	fputs("\t$(CFLAGS_EXTRA) $(GCC_CFLAGS_EXTRA) \\\n ", fpmake);
	fputs("\t$(SYMBOLIC) $(LOCAL_CFLAGS)\n\n", fpmake);
}

void
gen_sco_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
#if defined(FORCE_DASH_G)
	fputs("\t-g \\\n", fpmake);
#endif
	if (compiler == C_CC)
	{
#ifdef M_UNIX
		fputs("\t-nointl \\\n", fpmake);
		if ((sco_type != X_UNIX) && (sco_type != X_32v4))
			fputs("\t-xenix \\\n", fpmake);
#endif
		fputs(sco_cc_opts[sco_type], fpmake);
		if (sco_type == X_X286)
			fputs("\t-SEG 512 -F 5000 \\\n", fpmake);
	}
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", sco_libs[sco_type]);
}

void
gen_isc_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", isc_libs);
}

void
gen_motsvr3_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", motsvr3_libs);
}

void
gen_sun_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", sun_libs);
}

void
gen_solaris2_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", solaris2_libs);
}

void
gen_hpux_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", hpux_libs);
}

void
gen_svr4_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", svr4_libs);
}

void
gen_linux_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", linux_libs);
}

void
gen_bsd_ldflags()
{
	fputs("LDFLAGS = \\\n", fpmake);
	fputs("\t$(SYMBOLIC) $(LDFLAGS_EXTRA)\n\n", fpmake);

	fprintf(fpmake, "LIBS = %s\n\n", bsd_libs);
}

void
generate_config(mdir)
char *mdir;
{
	char mksrc[CBUFSIZE];
	char mkfl[CBUFSIZE];
	char s128[CBUFSIZE];
	FILE *fpsrc;
	FILE *local = fopen("config.local", "r");
	static int reported_config_local = 0;

	sprintf(mksrc, "%s/Make.src", mdir);
	sprintf(mkfl, "%s/Makefile", mdir);

	printf("Configuring %s from %s\n", mkfl, mksrc);

	if (!(fpsrc = fopen(mksrc, "r")))
	{
		perror(mksrc);
		return;
	}

	if (debug)
		fpmake = stdout;
	else
	{
		if (!(fpmake = fopen(mkfl, "w")))
		{
			perror(mkfl);
			fclose(fpsrc);
			if (local)
				fclose(local);
			return;
		}
	}

	fprintf(fpmake, "#-- configured by Configure revision %s for ECU 3.%02d\n",
		rev, PATCHLEVEL);
	fprintf(fpmake, "#-- edit %s and rerun Configure to produce this file\n\n",
		mksrc);

	if (local)
	{
		fprintf(fpmake, "# config.local inclusions\n");
		fprintf(fpmake, "# -----------------------\n");
		if (!reported_config_local)
			fputs("found config.local:\n", stdout);
		while (fgets(s128, sizeof(s128), local))
		{
			if (!reported_config_local)
				fputs(s128, stdout);
			fputs(s128, fpmake);
		}
		if (!reported_config_local)
			fputs("\n", stdout);
		reported_config_local = 1;
		fclose(local);
		fprintf(fpmake, "# -----------------------\n");
		fputs("\n", fpmake);
	}

	switch (sys)
	{
		case S_SCO:
			fprintf(fpmake, "SIGTYPE = %s\n\n", sco_sigtype[sco_type]);
			break;
		case S_ISC:
			fprintf(fpmake, "SIGTYPE = %s\n\n", isc_sigtype);
			break;
		case S_MOTSVR3:
			fprintf(fpmake, "SIGTYPE = %s\n\n", motsvr3_sigtype);
			break;
		case S_LINUX:
			fprintf(fpmake, "SIGTYPE = %s\n\n", linux_sigtype);
			break;
		case S_SUN:
			fprintf(fpmake, "SIGTYPE = %s\n\n", sun_sigtype);
			break;
		case S_ISCSVR4:
		case S_ESIXSVR4:
		case S_MOTSVR4:
		case S_SOLARIS2:
			fprintf(fpmake, "SIGTYPE = %s\n\n", svr4_sigtype);
			break;
		case S_HPUX:
			fprintf(fpmake, "SIGTYPE = %s\n\n", hpux_sigtype);
			break;
		case S_BSD:
			fprintf(fpmake, "SIGTYPE = %s\n\n", bsd_sigtype);
			break;
	}

	switch (compiler)
	{
		case C_CC:
			fputs("CC = cc\n", fpmake);
			gen_cc_cflags();
			break;
		case C_GCC:
			fputs("CC = gcc\n", fpmake);
			gen_gcc_cflags();
			break;
		default:
			printf("Cannot handle compiler type %d\n", compiler);
			goodbye(1);
	}
	gen_common_cflags();

	switch (sys)
	{
		case S_SCO:
			gen_sco_ldflags();
			break;
		case S_ISC:
			gen_isc_ldflags();
			break;
		case S_MOTSVR3:
			gen_motsvr3_ldflags();
			break;
		case S_SUN:
			gen_sun_ldflags();
			break;
		case S_SOLARIS2:
			gen_solaris2_ldflags();
			break;
		case S_ISCSVR4:
		case S_ESIXSVR4:
		case S_MOTSVR4:
			gen_svr4_ldflags();
			break;
		case S_LINUX:
			gen_linux_ldflags();
			break;
		case S_HPUX:
			gen_hpux_ldflags();
			break;
		case S_BSD:
			gen_bsd_ldflags();
			break;
	}

	fprintf(fpmake, "LBIN = %s\n", bindir);
	fprintf(fpmake, "ECULIBDIR = %s\n", libdir);

	/*
	 * we need this info in Makefiles, so it is put here rather than
	 * ecu.h; must also have this passed thru in CFLAGS
	 */
	switch (sys)
	{
		case S_SCO:
			fprintf(fpmake, "SYSTEM = %s\n", sco_system[sco_type]);
			fputs("HDBLIBDIR = /usr/lib/uucp\n", fpmake);
			break;
		case S_ISC:
			fputs("SYSTEM = ISC-SVR3\n", fpmake);
			fputs("HDBLIBDIR = /usr/lib/uucp\n", fpmake);
			break;
		case S_SUN:
			fputs("SYSTEM = SunOS-4.1\n", fpmake);
			fputs("HDBLIBDIR = /etc/uucp\n", fpmake);
			break;
		case S_SOLARIS2:
			fputs("SYSTEM = Solaris 2.x\n", fpmake);
			fputs("HDBLIBDIR = /etc/uucp\n", fpmake);
			break;
		case S_MOTSVR3:
			fputs("SYSTEM = MotSVR3\n", fpmake);
			fputs("HDBLIBDIR = /usr/lib/uucp\n", fpmake);
			break;
		case S_ISCSVR4:
			fputs("SYSTEM = ISC-SVR4\n", fpmake);
			fputs("HDBLIBDIR = /etc/uucp\n", fpmake);
			break;
		case S_ESIXSVR4:
			fputs("SYSTEM = ESIX-SVR4\n", fpmake);
			fputs("HDBLIBDIR = /etc/uucp\n", fpmake);
			break;
		case S_MOTSVR4:
			fputs("SYSTEM = MOTOROLA-SVR4\n", fpmake);
			fputs("HDBLIBDIR = /etc/uucp\n", fpmake);
			break;
		case S_LINUX:
			fputs("SYSTEM = Linux\n", fpmake);
			fputs("HDBLIBDIR = /usr/lib/uucp\n", fpmake);
			break;
		case S_HPUX:
			fputs("SYSTEM = HP-UX\n", fpmake);
			fputs("HDBLIBDIR = /usr/lib/uucp\n", fpmake);
			break;
		case S_BSD:
			fputs("SYSTEM = BSD\n", fpmake);
			break;
	}

	fprintf(fpmake, "CFG_UseUngetty = %s\n", use_ecuungetty);
#if !defined(WHT)
	fputs("#", fpmake);
#endif
	fputs("BINTIME = /bin/time\n", fpmake);

	fprintf(fpmake, "\n#---- end of configured make variables\n");

	while (!debug && fgets(s128, sizeof(s128), fpsrc))
		fputs(s128, fpmake);

	fclose(fpsrc);
	if (!debug)
		fclose(fpmake);

}

int
find_string_in_file(fname, str)
char *fname;
char *str;
{
	FILE *fp;
	char s128[128];
	int found = 0;

	printf("   Looking in %s ... ", fname);
	sprintf(s128, "fgrep %s %s 2>/dev/null", str, fname);
	if (!(fp = popen(s128, "r")))
	{
		printf("cannot `%s'", s128);
		perror(" ");
		return (0);
	}
	while (fgets(s128, sizeof(s128), fp))
	{
		char *cp = s128;
		int str_len = strlen(str);

		while (*cp)
		{
			if (!strncmp(cp, str, str_len))
			{
				found = 1;
				goto BREAK2;
			}
			cp++;
		}
	}
  BREAK2:
	fclose(fp);
	if (found)
		printf("found it!\n");
	else
		printf("not there.\n");
	return (found);
}

void
find_stuff()
{
	FILE *fp;
	char s128[128];
	char *cp;

	printf("Looking for `struct fd_set' ... \n");
	has_fd_set = 0;

	has_fd_set = find_string_in_file("/usr/include/sys/types.h", "fd_set");
	if (!has_fd_set)
	{
		if (has_fd_set = find_string_in_file("/usr/include/sys/select.h",
				"fd_set"))
		{
			need_select_h = 1;
		}
	}
	if (has_fd_set)
		printf("We'll use `struct fd_set' for select() arguments\n");
	else
	{
		printf("There is no `struct fd_set' in my visual range.\n");
		printf("So we'll use the old BSD int array bitmask for select().\n");
		printf("If I've missed my guess, you'll get harmless warnings\n");
		printf("about incorrect arguments to select().\n");
	}
	printf("\n");
	sleep(2);

	printf("Looking for `struct timeval' ... \n");
	has_timeval = 0;

	has_timeval = find_string_in_file("/usr/include/sys/time.h",
		"struct timeval");
	if (!has_timeval)
	{
		if (has_timeval = find_string_in_file("/usr/include/sys/select.h",
				"struct timeval"))
		{
			need_select_h = 1;
		}
	}
	if (has_timeval)
		printf("We'll need `struct timeval' for select() arguments\n");
	else
	{
		printf("There is no `struct timeval' in my visual range.\n");
		printf("We can't use select() for a nap() replacement.\n");
	}
	printf("\n");
	sleep(2);

}

void
config_setup()
{
	int itmp;

	/*
	 * set up raw/cooked tty setty() macro
	 */
#if defined(__NetBSD__)
	tcgetattr(0, &tty0);
#else
	ioctl(0, TCGETA, &tty0);
#endif
	tty1 = tty0;
	tty1.c_lflag &= ~(ICANON);
	tty1.c_cc[VMIN] = 1;
	tty1.c_cc[VTIME] = 0;

	/*
	 * any signal except death of a child causes abort
	 */
	for (itmp = 1; itmp < NSIG; itmp++)
	{
		if (
#ifdef SIGCLD
			(itmp == SIGCLD) ||
#endif /* SIGCLD */
#ifdef SIGCHLD				 /* duplicate work on some systems */
			(itmp == SIGCHLD) ||
#endif /* SIGCLD */
			0)
		{
			signal(itmp, SIG_IGN);
		}
		else
			signal(itmp, goodbye);
	}
}

main(argc, argv)
int argc;
char **argv;
{
	int itmp;
	int getopt_libdir = 0;
	int getopt_bindir = 0;
	int getopt_tty = 0;
	int getopt_baud = 0;
	int getopt_parity = 0;
	int getopt_intdial_to = 0;
	char s128[CBUFSIZE];
	char **makedir;
	char *tlib;
	char *tcap;
	struct stat fst;
	extern int optind;
	extern char *optarg;

	setbuf(stdin, NULL);
	setbuf(stdout, NULL);

	while ((itmp = getopt(argc, argv, "dsiSOIEMNlh23uvgcT:B:P:b:t:")) != -1)
	{
		switch (itmp)
		{
			case 'd':
				debug = 1;
				break;

			case 's':
				sys = S_SCO;
				break;
			case 'i':
				sys = S_ISC;
				break;
			case 'm':
				sys = S_MOTSVR3;
				break;
			case 'S':
				sys = S_SUN;
				break;
			case 'O':
				sys = S_SOLARIS2;
				break;
			case 'I':
				sys = S_ISCSVR4;
				break;
			case 'E':
				sys = S_ESIXSVR4;
				break;
			case 'M':
				sys = S_MOTSVR4;
				break;
			case 'l':
				sys = S_LINUX;
				break;
			case 'h':
				sys = S_HPUX;
				break;
			case 'N':
				sys = S_BSD;
				break;

			case '2':
				sco_type = X_X286;
				need_select_h = 1;
				break;
			case '3':
				sco_type = X_X386;
				need_select_h = 1;
				break;
			case 'u':
				sco_type = X_UNIX;
				need_select_h = 1;
				break;
			case 'v':
				sco_type = X_32v4;
				pid_type = "\t-DPID_T=pid_t \\\n";
				break;

			case 'g':
				compiler = C_GCC;
				break;
			case 'c':
				compiler = C_CC;
				break;

			case 'T':
				tty = optarg;
				getopt_tty = 1;
				break;

			case 'B':
				baud = optarg;
				getopt_baud = 1;
				break;

			case 'P':
				parity = *optarg;
				if (isupper(parity))
					parity = tolower(parity);
				getopt_parity = 1;
				break;

			case 'b':
				bindir = optarg;
				getopt_bindir = 1;
				break;

			case 't':
				intdial_to = atoi(optarg);
				getopt_intdial_to = 1;
				break;

		}
	}

	config_setup();

	if (!debug)
	{
		tputstrs(strs_intro1);
		printf("ECU 3.%02d, config version %s\n", PATCHLEVEL, rev);
		tputstrs(strs_intro2);
	}

	/*
	 * try to make a stab at default some vendor compilers have
	 * thoughtfully provided a reliable built-in default to ISC if not one
	 * of those two
	 */
	itmp = 'i';
#ifdef M_SYSV
	itmp = 's';
#endif
#ifdef sun
	itmp = 'S';
#endif
#if defined(hpux)
	itmp = 'h';
#endif
#if defined(m68k) || defined(m88k)
	itmp = 'M';
#endif
#if defined(MOTSVR3)
	itmp = 'm';
#endif
#if defined(__NetBSD__)
	itmp = 'N';
#endif
#if defined (sun) && defined (__svr4__)

	/*
	 * line 27 of gcc/config/sparc/sol2.h in CPP_PREDEFINES. Your mileage
	 * may vary.....
	 */
	itmp = 'O';
#endif

	if (sys < 0)
	{
		switch (tgetopt("\
Choose your system type (or the `nearest equivalent')\n\
      s  SCO ODT/UNIX                   S  SunOS 4.1\n\
      h  HP-UX 9.01 or later            O  Solaris 2.x\n\
      M  Motorola Delta SVR41/[68]8k    i  ISC SVR32 (2.2 or later)\n\
      m  Motorola Delta SVR32/[68]8k    I  ISC SVR4\n\
      l  Linux pl10 or later            E  ESIX SVR4\n\
      N  NetBSD\n\
\n\
",
				"shlMmNSOiIE", itmp))
		{
			case 's':
				sys = S_SCO;
				tty = "tty1a";
				break;
			case 'i':
				sys = S_ISC;
				tty = "acu00";
				break;
			case 'm':
				sys = S_MOTSVR3;
				tty = "tty00";
				break;
			case 'M':
				sys = S_MOTSVR4;
				tty = "ttys0";
				break;
			case 'S':
				sys = S_SUN;
				tty = "ttya";
				printf(
					"\nYou need System V IPC configured in your kernel. I didn't check for it.\n");
				break;
			case 'O':
				sys = S_SOLARIS2;
				tty = "ttya";
				break;
			case 'I':
				sys = S_ISCSVR4;
				tty = "tty00";
				break;
			case 'E':
				sys = S_ESIXSVR4;
				tty = "tty00";
				break;
			case 'l':
				sys = S_LINUX;
				tty = "ttyS0";
				compiler = C_GCC;
				printf("\
\nAll Linux are not created equal.  You may need to be root to do the make.\n\
Also, you may see many `warning: overflow in implicit constant conversion'\n\
and `passing arg 3 of `tputs' from incompatible pointer type' that you\n\
may safely ignore. Gcc will be used for all LINUX compilations.\n");
				break;
			case 'h':
				sys = S_HPUX;
				tty = "cul00";
				break;
			case 'N':
				sys = S_BSD;
				tty = "com1";
				compiler = C_GCC;
				printf("Gcc will be used for all compilations.\n");
				can_pipe = 1;
				break;
		}
	}

	if ((sys == S_SCO) && (sco_type < 0))
	{
		switch (tgetopt("\
Choose between 2  XENIX/286,\n\
               3  XENIX/386,\n\
               u  ODT 1.0.x, ODT 1.1, UNIX 3.2.0-3.2v2 or\n\
               v  ODT 2.0, UNIX 3.2v4 or later\n\
 ",
				"23uv",
#ifdef M_UNIX
				'v'
#else
#ifdef M_I286
				'2'
#else
#ifdef M_I286
				'3'
#else
#ifdef sun
				'S'
#else
				'h'
#endif
#endif
#endif
#endif
			))
		{
			case '2':
				need_select_h = 1;
				sco_type = X_X286;
				compiler = C_CC;	/* I don't know about gcc on 286
									 * systems */
				tlib = "/lib/Llibtermlib.a";
				tcap = "/lib/Llibtermcap.a";
				break;
			case '3':
				need_select_h = 1;
				sco_type = X_X386;
				tlib = "/lib/386/Slibtermlib.a";
				tcap = "/lib/386/Slibtermcap.a";
				break;
			case 'u':
				sco_type = X_UNIX;
				need_select_h = 1;
				tlib = "/usr/lib/libtermlib.a";
				tcap = "/usr/lib/libtermcap.a";
#ifdef S_IFLNK				 /* 3.2v2 DS with 3.2v4 OS (sys/ hdr files
							  * supplied with OS) */
				fputs("OK, we will try to make for 3.2v4 with a 3.2v2 DS\n",
					stdout);
#endif
				break;
			case 'v':
				sco_type = X_32v4;
				pid_type = "\t-DPID_T=pid_t\\\n";
				tlib = "/usr/lib/libtermlib.a";
				tcap = "/usr/lib/libtermcap.a";
				break;
		}

		/*
		 * multivariate SCO development environment
		 */
		if (!access(tcap, 0))
			sco_libs = _sco2_libs;
		else if (!access(tlib, 0))
			sco_libs = _sco_libs;
		else
		{
			sleep(1);		 /* psychological */
			printf("\nI find neither %s nor %s.\n", tcap, tlib);
			printf("Do you have curses support installed? I cannot proceed.\n");
			goodbye(1);
		}

	}

	if (compiler < 0)
	{
		switch (tgetopt("If you use gcc, it MUST be 1.40 or later.\n\
Do you wish to use cc or gcc", "cg", 'c'))
		{
			case 'c':
				compiler = C_CC;
				break;

			case 'g':
				compiler = C_GCC;
#ifdef PEDANTIC
				printf("I see we are being brave, er pedantic.\n\n");
#endif
				switch (sys)
				{
					case S_SUN:
					case S_SOLARIS2:
						can_pipe = 1;	/* native as reads from stdin ok */
						break;
					case S_ISCSVR4:
					case S_ESIXSVR4:
						can_pipe = 1;
						break;
					default:
						switch (tgetopt("Answer no if you are not sure.\n\
Can I use -pipe (do you have gas?)", "yn",
								'n'))
						{
							case 'y':
								can_pipe = 1;
								break;
						}
						break;
				}

				break;
		}
	}

	if (compiler == C_GCC)
	{
		printf("\
\nYou may safely ignore a large number of `overflow in implicit constant\n\
conversion' and `empty body in else-statement' warnings that some versions\n\
of gcc may emit.\n");
	}

	/*
	 * ecuungetty support
	 */
#if defined(M_SYSV) || defined(ISC) || defined(MOTSVR3)
	switch (tgetopt("\
If you have gettys running on any of your modem lines, you want\n\
to use ecuungetty to manage the shared dial-in/dial-out protocol.\n\
If you do not have dial-in access to your computer, you may wish to\n\
omit ecuungetty support.  Answer 'y' if you are not sure.\n\
Do you want ecuungetty support? ", "yn", 'y'))
	{
		case 'y':
			use_ecuungetty = "yes";
			break;
		case 'n':
			use_ecuungetty = "no";
			break;
	}
#endif /* defined(M_SYSV) || defined(ISC) || defined(MOTSVR3) */

	if (!getopt_tty)
	{
		printf("\nWhat do you want for a default tty? [%s]\n:", tty);
		tgets(s128);
		if (s128[0])
			tty = strdup(s128);
	}

	if (!getopt_baud)
	{
		printf("\nWhat do you want for a default baud rate? [%s]\n:", baud);
		tgets(s128);
		if (s128[0])
			baud = strdup(s128);
	}

	if (!getopt_parity)
	{
		parity = tgetopt("What do you want for default parity", "neo", 'n');
	}

	if (!getopt_bindir)
	{
		printf(
			"\nWhere do you want the public executables placed? [%s]\n: ",
			bindir);
		tgets(s128);
		if (s128[0])
			bindir = strdup(s128);
	}

	if (!getopt_libdir)
	{
		printf(
			"\nWhere do you want the ECU library placed? [%s]\n: ", libdir);
		tgets(s128);
		if (s128[0])
			libdir = strdup(s128);
	}

	if (!getopt_intdial_to)
	{
		printf("\nHow many seconds should the built-in dialer ");
		printf("wait for carrier? [%d]\n: ", intdial_to);
		tgets(s128);
		if (s128[0])
			intdial_to = atoi(s128);
	}

	printf("\nThank you.\n\n");
	find_stuff();

	makedir = makedirs;
	while (*makedir)
	{
		if (!strcmp(*makedir, "./ecuungetty") && (*use_ecuungetty == 'n'))
		{
			makedir++;
			continue;
		}
		generate_config(*makedir++);
	}

	/*
	 * check on our buddy timeval
	 */
	if (need_timeval && !has_timeval)
	{
		tputstrs(strs_no_timeval);
		goodbye(1);
	}

	/*
	 * urge make depend for some
	 */
	if (!debug)
		tputstrs(strs_mkdep);

#ifdef WHT
	printf("\7Doing it anyway for WHT\n");
	sleep(2);
	for (itmp = 1; itmp < NSIG; itmp++)
		signal(itmp, SIG_DFL);
	system("make depend");
#endif

	goodbye(0);
}

/* vi: set tabstop=4 shiftwidth=4: */
/* end of config.c */
